#include <iostream>
#include <ros/ros.h>
#include "regionmapper.h"

//=============================================================================
// HACK Debugger attach wait function taken from:
//       http://www.open-mpi.org/faq/?category=debugging
// Print the output pid then sleep. When you attach to the process you
// need to set the value of i to a non-zero. Eg. in GDB: (gdb) set var i = 7
//=============================================================================
void debugger_attach_hack()
{
    int i = 0;
    char hostname[256];
    gethostname(hostname, sizeof(hostname));
    std::cerr << "PID " << getpid() << " on " << hostname
    		  << " ready for attach" << std::endl;
    while (0 == i)
        sleep(5);
}

int main(int argc, char** argv)
{
  try
  {

//	  debugger_attach_hack();

	  ros::init(argc, argv, "region_finder");

	  RegionMapper rm;
	  ros::spin();
	  return (0);
  }
  catch (const boost::exception& e)
  {
    std::cerr << diagnostic_information(e) << std::endl;
  }
  catch (const std::exception& e)
  {
    std::cerr << e.what() << std::endl;
  }
  catch (...)
  {
    std  ::cerr << "Caught unknown exception. Shuting down." << std::endl;
  }
}
